unit DD63u1;

//Visit http://sheepdogguides.com/dt5h.htm for more information about this.

//Weatherduck, if given a "B", and LEFT IN PEACE *WILL* give a good
//account of condions over a time period. The tture reading WILL
//change, even if it does NOT seem to change if multiple, frequent
//"B"s issued.  "B" causes start "transmit report every 90 seconds"

//before long... do something to drop old lines in memo, keep new, and keep
// new visible. Essential for long term proper poperation of TM128 reading.

//DO NOT TAMPER WITH DD62!! Work with derivatives, like this, DD63.
//FOR SOME REASON DD62, with all it's warts, "works" for PHAnderson TM#128
//  and WeatherDuck, sort of. DO NOT DISTURB!!!!!

(*//PROBLEM: PROGRAM DOES NOT continually fully empty serial port buffer...

Two terms, slightly mis-used, but useful:
Host: The "big PC" DD63 will be run in. Term not mis-used much.
"Server": The little device, attached to the host via a serial cable.
   when the host sends something to the server, the server will respond.

Discoveries to date:
  1) Set  ComPort1 ReceiveMode rmTERM, and Terminator to #13.
  This will "parse" data stream into "lines"... where "line" is
  anything ending with a #13.

  2) I've decided, for these needs, to assume that the server always sends
  at least a #13 at the ends of lines. It may or may not send one or more
  #10s, which DD63 is throwing away. Note that for the memo displaying
  the server's response, some #10s may be being added by DD63, to help
  make the display more easily readable.

  3) Note that the display is cleared if it gets to 500 lines of text.

  4) If the rbWeatherDuck radiobutton is checked when sbuOpenPort is clicked,
  the program will automatically set the RTS and DTR lines high. The WeatherDuck
  draws it's operating power from one or both of these "signal" lines.)

  5)

  //////SCRAPS TO EDIT  v v v v v
   (which has some features I want!... saves(maybe only one of them... but at least one of them) to be high. (The WeatherDuck
  need for my function boLineEnded. Sadly, when datasource is sending
  short strings, they aren't seen until several have accumulated...
  So WeatherDuck, for instance, "falls over" when reporting, say, H
  Really CRUDE "answer": Ask for any given requirement several times, e.g.
  H,H,H... use answer to first (which will be "popped" off stack by
  subsequent requests), and ignore answer to 2nd, 3rd, whatever, when they
  emerge later before the answer to the current request for info. MESSY...
  and doesn't work: "Stuff" accumulates. Yuck!
  Weatherduck "answer", also messy, but seems to work:
  Send "D". Causes duck to send ALL it knows. Parse, use.

  For some reason.. touch wood... PHAnderson's TM#128 works okay, in
    spite of sending short messages. Hmmm.

  //////END ^ ^ ^ ^ SCRAPS TO EDIT


(*Simple "Hyperterminal" replacement. Originally written to interact
  with WeatherDuck and Peter Anderson's TM#128 1-Wire interface, but
  probably of general interest / applicablilty. Should also be okay
  for Pascalite.

  Requires Dirk Claessens' TComPort component, which is freeware
  with sourcecode. I don't generally like installing extra components,
  but for serial comms... do yourself a favor!!!

  REMEMBER: FOR WEATHERDUCK, rts and/or dtr MUST BE HIGH, and HANDSHAKE
  MUST BE NONE.

*)

(*DD63 from DD62, which was derived from Dirk Claessens' "Example", which
  he gives away with his TComPort component. It will install into Delphi 2.

  "Example" and TComPort were harvested from....

  users.pandora.be/dirk.claessens2/

  ... click on the "Downloads" menu item.

  There you will find: "All downloads are freeware... use at your own risk."
  There is a whole bunch of interesting things, many related to TCP/IP*)
(*

=====================================================================
NOTE Delphi 4 : BEFORE you try to compile this program,
   FIRST install Compack.bpl
=====================================================================
From Delphi's IDE :
  Component > Install Packages > Add > select compack.bpl > OK
 (TComport will be installed on the Samples page)

 do *NOT* follow this procedure with D5 !



=====================================================================
NOTE Delphi 5 : BEFORE you try to compile this example program,
   FIRST install Comport.pas
=====================================================================
From Delphi's IDE :

  Component > Install > Into New Package
    Unit file name    :   Browse to comport.pas > OK
    Package File name :   Browse to directory of comport.pas, type a name of
    your choice, "ComPort" for example > OK
      etc..  > OK  etc.. OK

 (TComport will be installed on the Samples page)


*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Comport, StdCtrls, ExtCtrls, Buttons, Grids;

const ver='12 June 05';
//started 23 June 05 for interface to WeatherDuck and PHAnderson TM#128
//DD63 from DD62, which was derived from Dirk Claessens' "Example", which
//        he gives away with his TComPort component.

type TadNum=array[0..15] of double;

type
  TDD63f1 = class( TForm )
    meRawReturns: TMemo;
    buSetRTS: TButton;
    buClrRTS: TButton;
    buSetDTR: TButton;
    buClrDTR: TButton;
    eTextToSend: TEdit;
    GroupBox1: TGroupBox;
    shCarrier: TShape;
    shCTS: TShape;
    shDSR: TShape;
    shRing: TShape;
    shPortOpen: TShape;
    shError: TShape;
    cbPorts: TComboBox;
    ComPort1: TComPort;
    sbuOpenPort: TSpeedButton;
    SpeedButton2: TSpeedButton;
    sbSend: TSpeedButton;
    Image1: TImage;
    paDevice: TPanel;
    rbWeatherDuck: TRadioButton;
    rbTM128: TRadioButton;
    laStatusPortOpen: TLabel;
    laStatusCarrier: TLabel;
    laStatusCTS: TLabel;
    laStatusDSR: TLabel;
    laStatusRing: TLabel;
    laStatusError: TLabel;
    laTxtCantChange: TLabel;
    paWeatherDuck: TPanel;
    laTxtMicroLanNo: TLabel;
    laTxtTTC: TLabel;
    laTxtTTF: TLabel;
    laTxtR2: TLabel;
    laTxtHum: TLabel;
    laTxtR3: TLabel;
    laTxtLight: TLabel;
    laTxtAirflow: TLabel;
    laTxtR1: TLabel;
    laTtureF: TLabel;
    laTtureC: TLabel;
    laHum: TLabel;
    laLight: TLabel;
    laAirFlow: TLabel;
    laR1: TLabel;
    laR3: TLabel;
    laR2: TLabel;
    paTM128: TPanel;
    Timer1: TTimer;
    buTestTM128DataParsing: TButton;
    sgTtures: TStringGrid;
    sgCounter: TStringGrid;
    sgBatMon: TStringGrid;
    sgADC: TStringGrid;
    paInBit: TPanel;
    laTM128InBit: TLabel;
    laTxtInBit: TLabel;
    paTM128Repeatedly: TPanel;
    paWDRepeatedly: TPanel;
    meWDRepMsg: TMemo;
    buWDSendB: TButton;
    buTM128Repeatedly: TButton;
    rbTM128R0: TRadioButton;
    rbTM128R1: TRadioButton;
    rbTM128R2: TRadioButton;
    rbTM128R3: TRadioButton;
    rbTM128R4: TRadioButton;
    rbTM128R5: TRadioButton;
    laTM128RepeatSpeed: TLabel;
    laTM128HowOften: TLabel;
    procedure btnOpenClick( Sender: TObject );
    procedure btnCloseClick( Sender: TObject );
    procedure btnSendClick( Sender: TObject );
    procedure buSetRTSClick( Sender: TObject );
    procedure buClrRTSClick( Sender: TObject );
    procedure buSetDTRClick( Sender: TObject );
    procedure buClrDTRClick( Sender: TObject );
    procedure FormCreate( Sender: TObject );
    procedure FormDestroy( Sender: TObject );
    procedure ComPort1CTSChanged( Status: Boolean );
    procedure ComPort1DSRChanged( Status: Boolean );
    procedure ComPort1Error( Sender: TObject );
    procedure ComPort1PortClose( Sender: TObject );
    procedure ComPort1PortOpen( Sender: TObject );
    procedure ComPort1RingChanged( Status: Boolean );
    procedure ComPort1RLSDChanged( Status: Boolean );
    procedure ComPort1ReceiveCallBack( Data: string );
    procedure eTextToSendKeyPress( Sender: TObject; var Key: Char );
    procedure rbWeatherDuckClick(Sender: TObject);
    procedure rbTM128Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure buTestTM128DataParsingClick(Sender: TObject);
    procedure buWDSendBClick(Sender: TObject);
    procedure buTM128RepeatedlyClick(Sender: TObject);
    procedure rbTM128RClick(Sender: TObject);
  private
    { Private declarations }
    sTextFrmPort:string;
    asiNums:TadNum;
    toNull:TObject;//For use when calling click handlers "by code"
    //the variables on the next line are for TM128 dta output.
    iNextTtureRow,iNextADCRow,iNextCounterRow,iNextBatMonRow:integer;
    boTM128MsgGivenOnce:boolean;
    function RemoveSomeCharacters(sTmp:string):string;
    procedure InterpretRecentLines;
    procedure StringOfNums(sRaw:string;var asiNumbers:TadNum);
  public
    { Public declarations }
  end;

var
  DD63f1:TDD63f1;

implementation

{$R *.DFM}
{$R+}

//======= material from Claessens' "Example" ============
procedure TDD63f1.FormCreate( Sender: TObject );
begin
boTM128MsgGivenOnce:=false;
{rbTM128Click(toNull);//or...}rbWeatherDuckClick(toNull);
(*Start material from Claessens' "Example"*)
  EnumPorts( cbPorts.Items );
  if cbPorts.Items.Count > 0 then
    cbPorts.ItemIndex := 0; // show first available port
(*End material from CClaessens' "Example"*)

//Begin prepare TM128 display
sgTtures.cells[0,0]:='ID';
sgTtures.cells[1,0]:='Tture';
iNextTtureRow:=1;

sgADC.cells[0,0]:='ID';
sgADC.cells[1,0]:='ADCa';
sgADC.cells[2,0]:='ADCb';
sgADC.cells[3,0]:='ADCc';
sgADC.cells[4,0]:='ADCd';
iNextADCRow:=1;

sgCounter.cells[0,0]:='ID';
sgCounter.cells[1,0]:='Page 14';
sgCounter.cells[2,0]:='Page 15';
iNextCounterRow:=1;

sgBatMon.cells[0,0]:='ID';
sgBatMon.cells[1,0]:='Tture';
sgBatMon.cells[2,0]:='Vad';
sgBatMon.cells[3,0]:='Vdd';
iNextBatMonRow:=1;

timer1.interval:=60000;//bad hard coding of init state!

end;

//======== material from Claessens' "Example" ===========
procedure TDD63f1.FormDestroy( Sender: TObject );
begin
  ComPort1.Free;
end;

//======= material from Claessens' "Example" ============
procedure TDD63f1.btnOpenClick( Sender: TObject );
begin
(*Start material from Claessens' "Example"*)
  cbPorts.Enabled := false;
  ComPort1.Port := cbPorts.Items[cbPorts.ItemIndex];
  ComPort1.Open;
(*End material from CClaessens' "Example"*)
laTxtCantChange.caption:='Cannot be changed while port open';
paDevice.enabled:=false;
sbSend.enabled:=true;
buWDSendB.enabled:=true;
buTM128Repeatedly.enabled:=true;
sTextFrmPort:='';
eTextToSend.text:='B';
//D will do as well as anything to trigger response from TM#128
//For WeatherDuck, it is, official, to end the loop of repeated
//   responses... but it also triggers a "one off response".
if rbWeatherDuck.checked then begin
   buSetRTSClick(self);//"self" not used, just needed
   buSetDTRClick(self);//  to satisfy call's requirements.
   end;
end;//btnOpenClick

//======= material from Claessens' "Example" ============
procedure TDD63f1.btnCloseClick( Sender: TObject );
begin
  ComPort1.Close;
  cbPorts.Enabled := true;
  sbSend.enabled:=false;
  buWDSendB.enabled:=false;
  buTM128Repeatedly.enabled:=false;
//  TKB added the following...
laTxtCantChange.caption:='Can only be changed while port closed';
paDevice.enabled:=true;
end;

//======= material from Claessens' "Example" ============
procedure TDD63f1.ComPort1ReceiveCallBack(Data: string);
//Modified by TKB to put a "line" at a time on screen, etc
function boLineEnded(var sTextFrmPort:string; var sToDisplay:string):boolean;
  var c1:byte;
  begin
  result:=false;
  c1:=pos(#13,sTextFrmPort);
  if c1>0 then begin
  //NB: THIS IS CRUDE!! ASSUMES #13 as line end ,
  //And does nothing about or with #10s
    sToDisplay:=copy(sTextFrmPort,1,c1-1);
    sTextFrmPort:=copy(sTextFrmPort,c1+1,length(sTextFrmPort)-c1);
    result:=true;
    end;
  end;//boLineEnded
var sTmp:string;
begin //ComPort1ReceiveCallBack
  if meRawReturns.Lines.Count > 500 then
    meRawReturns.Clear;
  Data:=RemoveSomeCharacters(Data);//TKB addition
  sTextFrmPort:=sTextFrmPort+Data;
  if boLineEnded(sTextFrmPort,sTmp) then begin
    meRawReturns.Lines.Add(sTmp);
    InterpretRecentLines;
    end;
  Image1.Visible := not Image1.Visible;
end; //ComPort1ReceiveCallBack

//======= material from Claessens' "Example" ============
procedure TDD63f1.ComPort1CTSChanged( Status: Boolean );
begin
  case Status of
    true: shCTS.Brush.Color := clLIME;
    false: shCTS.Brush.Color := clGRAY;
  end;
end;

//======= material from Claessens' "Example" ============
procedure TDD63f1.ComPort1DSRChanged( Status: Boolean );
begin
  case Status of
    true: shDSR.Brush.Color := clLIME;
    false: shDSR.Brush.Color := clGRAY;
  end;
end;

//======= material from Claessens' "Example" ============
procedure TDD63f1.ComPort1Error( Sender: TObject );
begin
  shError.Brush.Color := clRED;
end;

//======= material from Claessens' "Example" ============
procedure TDD63f1.ComPort1PortOpen( Sender: TObject );
begin
  shPortOpen.Brush.Color := clYELLOW;
end;

//======= material from Claessens' "Example" ============
procedure TDD63f1.ComPort1PortClose( Sender: TObject );
begin
  shPortOpen.Brush.Color := clGRAY;
  shCarrier.Brush.Color := clGRAY;
  shRing.Brush.color := clGRAY;
  shCTS.Brush.Color := clGRAY;
  shDSR.brush.color := clGRAY;
end;

//======= material from Claessens' "Example" ============
procedure TDD63f1.ComPort1RingChanged( Status: Boolean );
begin
  case status of
    true: shRing.Brush.Color := clLIME;
    false: shRing.Brush.Color := clGRAY;
  end;
end;

//======= material from Claessens' "Example" ============
procedure TDD63f1.ComPort1RLSDChanged( Status: Boolean );
begin
  case Status of
    true: shCarrier.Brush.Color := clLIME;
    false: shCarrier.Brush.Color := clGRAY;
  end;
end;

//======= material from Claessens' "Example" ============
procedure TDD63f1.eTextToSendKeyPress( Sender: TObject; var Key: Char );
begin
  if Key = #13 then
  begin
    BtnSendClick( Sender );
    Key := #0;
  end;
end;

//======= material from Claessens' "Example" ============
procedure TDD63f1.btnSendClick( Sender: TObject );
var sTmp:string;
begin
  meRawReturns.clear;//remove when proper scrolling implemented
  ComPort1.send( eTextToSend.Text{ + #13#10 });
//  while sTmp='' do begin
//     application.processmessages;
//     ComPort1ReceiveCallBack(sTmp);// DOESN'T FIX "buffer not emptied" problem.
//     end;
end;

//======= material from Claessens' "Example" ============
procedure TDD63f1.buSetRTSClick( Sender: TObject );
begin
  ComPort1.SetRTS( true );
end;

//======= material from Claessens' "Example" ============
procedure TDD63f1.buClrRTSClick( Sender: TObject );
begin
  ComPort1.SetRTS( false );
end;

//======= material from Claessens' "Example" ============
procedure TDD63f1.buSetDTRClick( Sender: TObject );
begin
  ComPort1.SetDTR( true );
end;

//======= material from Claessens' "Example" ============
procedure TDD63f1.buClrDTRClick( Sender: TObject );
begin
  ComPort1.SetDTR( false );
end;

function TDD63f1.RemoveSomeCharacters(sTmp:string):string;
//Clumsy... recode.
//NO GOOD FOR SHORT LINES....
const allowed='abcdefghijklmnopqrstuvwxyz'+
    'ABCDEFGHIJKLMNOPQRSTUVWXYZ'+
    '0123456789'+
    '<>;:=-_.,@[]{}'+
    #9#13#32;{CR,Space,tab. LF(#10) LEFT OUT ON PURPOSE
         Including LF processing complicates "end of line"
         work considerably.}
var c1,c2:byte;
begin
c2:=length(sTmp);
result:='';
for c1:=1 to c2 do begin
    if pos(sTmp[c1],allowed)<>0 then result:=result+sTmp[c1];
    end;
end;

(*Typical "D" response from WeatherDuck:
  26.88,80.38,47,13,18,99,99,99
  which means: Tture was 26.88 C (which is 80.38 F),
      Humidity:47
      Airflow: 13
      Light level: 18
      Input 1: 99
      Input 2: 99
      Input 3: 99*)



procedure TDD63f1.rbWeatherDuckClick(Sender: TObject);
begin
if sender<>self then rbWeatherDuck.checked:=true;
paTM128.hide;
paWeatherDuck.show;
paWDRepeatedly.show;
paTM128Repeatedly.hide;
sbuOpenPort.enabled:=true;
end;

procedure TDD63f1.rbTM128Click(Sender: TObject);
begin
if sender<>self then rbTM128.checked:=true;
paWeatherDuck.hide;
paTM128.show;
sbuOpenPort.enabled:=true;
paTM128Repeatedly.show;
paWDRepeatedly.hide;
end;

procedure TDD63f1.Timer1Timer(Sender: TObject);
begin
btnSendClick(toNull);
end;

procedure TDD63f1.StringOfNums(sRaw:string;var asiNumbers:TadNum);
(*If passed, say '1.2,x,15' in sRaw, returns array filled with...
  1.2, -99.99, 15, -99.99, -99.99, -99.99, -99.99 *)
var c1:byte;
    sTmp:string;
  procedure Chop(var sOut,sIn:string);
  //If passed sIn='12,34,56', then proc
  //converts it to 34,56, and passes 12 back in sOut
  var bPosnOfComma:byte;
  begin
  bPosnOfComma:=pos(',',sIn);
  if bPosnOfComma=0 then begin
     sOut:=sIn;
     sIn:='';
     end // no ; here
   else begin
     sOut:=copy(sIn,1,bPosnOfComma-1);
     sIn:=copy(sIn,bPosnOfComma+1,length(sIn)-bPosnOfComma);
     end;//else
  end;//sub-proc "Chop"
begin
for c1:=0 to 15 do asiNumbers[c1]:=-999.99;//establish rogue values
c1:=0;
while length(sRaw)>1 do begin
  Chop(sTmp,sRaw);
  //showmessage(sTmp);
  try
     asiNumbers[c1]:=strtofloat(sTmp);
  except
     on EConvertError do ;//do nothing
     end;//try
  inc(c1);
  end;//while
end;//StringOfNums

procedure TDD63f1.buTestTM128DataParsingClick(Sender: TObject);
//button normally not visible. This is a test routine
begin
meRawReturns.clear;//remove when proper scrolling implemented

meRawReturns.lines.add('0');
meRawReturns.lines.add('10 20 29AE 3.781 0.655 0.066 0.9');
meRawReturns.lines.add('11 10 6A0B 35.56');
meRawReturns.lines.add('12 10 6A0C 53.56');
meRawReturns.lines.add('13 1D 1234 00001234 00005678');
meRawReturns.lines.add('20 26 09CE 33.93 0.12 4.95');
meRawReturns.lines.add('21 26 19CE 1.93 0.134 4.96');
meRawReturns.lines.add('22 26 29CE 22.93 0.10 4.97');
InterpretRecentLines;
end;

procedure TDD63f1.InterpretRecentLines;
var cPlaceInMemo,c1:integer;
    sRawData,sDallasFamily,sTmp:string;

    //Subroutines for TM128
    procedure ClearTM128StringGrids;
    var c1,c2:integer;
    begin
    for c1:=1 to sgTtures.ColCount do
     for c2:=1 to sgTtures.RowCount do sgADC.cells[c2,c1]:='';
    iNextTtureRow:=1;
    for c1:=1 to sgADC.ColCount do
     for c2:=1 to sgADC.RowCount do sgADC.cells[c2,c1]:='';
    iNextADCRow:=1;
    for c1:=1 to sgCounter.ColCount do
     for c2:=1 to sgCounter.RowCount do sgADC.cells[c2,c1]:='';
    iNextCounterRow:=1;
    for c1:=1 to sgBatMon.ColCount do
     for c2:=1 to sgBatMon.RowCount do sgADC.cells[c2,c1]:='';
    iNextBatMonRow:=1;
    end;

    procedure ProcessInputBit;
    //sRawData= 0 or 1
    begin
    if sRawData='0'
      then laTM128InBit.caption:='  Low'//no ; here
      else laTM128InBit.caption:='High or floating';
    cPlaceInMemo:=-1;//to prevent reading earlier lines than this
    end;

    function sNextNumber:string;
    //Bad programming... accesses sRawData, and needs value in c1,
    //     but not too awful...
    //Fetches next number, as defined by space or end of sRawData
    begin
    sTmp:='';
    while (c1<=length(sRawData))and(sRawData[c1]<>' ') do begin
       sTmp:=sTmp+sRawData[c1];
       inc(c1);
       end;
    if sRawData[c1]=' ' then inc(c1);
    result:=sTmp;
    end;

    procedure ProcessTture;
    //Sample sRawData:10 22 5BF2 2.36 (Near freezing!)
    //Has no protection against having more sensors than rows
    //......but program seems to run okay when there are!
    begin
    sgTtures.cells[0,iNextTtureRow]:=copy(sRawData,7,4);
    sTmp:=copy(sRawData,12,1);
    c1:=12;
    sgTtures.cells[1,iNextTtureRow]:=sNextNumber;
    inc(iNextTtureRow);
    if iNextTtureRow<sgTtures.RowCount then begin
      sgTtures.cells[0,iNextTtureRow]:='';
      sgTtures.cells[1,iNextTtureRow]:='';
      end;
    end;
    procedure ProcessDS2438;
    //Sample sRawData:11 26 09CE 33.93 0.11 4.95
    //Has no protection against having more sensors than rows
    begin
    sgBatMon.cells[0,iNextBatMonRow]:=copy(sRawData,7,4);//id
    c1:=12;
    sgBatMon.cells[1,iNextBatMonRow]:=sNextNumber;
    sgBatMon.cells[2,iNextBatMonRow]:=sNextNumber;
    sgBatMon.cells[3,iNextBatMonRow]:=sNextNumber;
    inc(iNextBatMonRow);
        if iNextBatMonRow<sgBatMon.RowCount then begin
      sgTtures.cells[0,iNextBatMonRow]:='';
      sgTtures.cells[1,iNextBatMonRow]:='';
      sgTtures.cells[2,iNextBatMonRow]:='';
      sgTtures.cells[3,iNextBatMonRow]:='';
      end;
    end;
    procedure ProcessCounter;
    //Sample sRawData:12 1D C827 00001234 00005678
    //Has no protection against having more sensors than rows
    begin
    sgCounter.cells[0,iNextCounterRow]:=copy(sRawData,7,4);//id
    sgCounter.cells[1,iNextCounterRow]:=copy(sRawData,12,8);
    sgCounter.cells[2,iNextCounterRow]:=copy(sRawData,21,8);
    inc(iNextCounterRow);
        if iNextCounterRow<sgCounter.RowCount then begin
      sgTtures.cells[0,iNextCounterRow]:='';
      sgTtures.cells[1,iNextCounterRow]:='';
      sgTtures.cells[2,iNextCounterRow]:='';
      end;
    end;
    procedure ProcessQuadADC;
    //Sample sRawData:13 20 29AE 0.065 0.066 .0123 4.999
    //Has no protection against having more sensors than rows
    begin
    sgADC.cells[0,iNextADCRow]:=copy(sRawData,7,4);//id
    c1:=12;
    sgADC.cells[1,iNextADCRow]:=sNextNumber;
    sgADC.cells[2,iNextADCRow]:=sNextNumber;
    sgADC.cells[3,iNextADCRow]:=sNextNumber;
    sgADC.cells[4,iNextADCRow]:=sNextNumber;
    inc(iNextADCRow);
        if iNextADCRow<sgADC.RowCount then begin
      sgTtures.cells[0,iNextADCRow]:='';
      sgTtures.cells[1,iNextADCRow]:='';
      sgTtures.cells[2,iNextADCRow]:='';
      sgTtures.cells[3,iNextADCRow]:='';
      sgTtures.cells[4,iNextADCRow]:='';
      end;
    end;

     //end of subroutines for TM128

begin//InterpretRecentLines
cPlaceInMemo:=meRawReturns.lines.count;
while (meRawReturns.lines[cPlaceInMemo]='') and (cPlaceInMemo>0) do dec(cPlaceInMemo);
  //"first" line is, apparently "line 0"
sRawData:=meRawReturns.lines[cPlaceInMemo];

if rbWeatherDuck.Checked then begin
StringOfNums(sRawData,asiNums);
laTTureC.caption:=floattostr(asiNums[0]);
laTtureF.caption:=floattostr(asiNums[1]);
laHum.caption:=floattostr(asiNums[2]);
laAirFlow.caption:=floattostr(asiNums[3]);
laLight.caption:=floattostr(asiNums[4]);
laR1.caption:=floattostr(asiNums[5]);
laR2.caption:=floattostr(asiNums[6]);
laR3.caption:=floattostr(asiNums[7]);
end;//WeatherDuck

if rbTM128.Checked then begin
//Generalised start of routine will
//already have filled sRawData with most recent
//non-null line, and c1 will point to previous
//line.
if (cPlaceInMemo>-1) and (sRawData<>'') then begin //at least one...
ClearTM128StringGrids;
repeat
if length(sRawData)=1 then ProcessInputBit //no ; here
  else begin //process others
     sDallasFamily:=copy(sRawData,4,2);
     if (sDallasFamily='10') or (sDallasFamily='22') or (sDallasFamily='28')
       then ProcessTture;
     if (sDallasFamily='26')
       then ProcessDS2438;//Tture/vad/vdd. "Battery monitor"
     if (sDallasFamily='1D')
       then ProcessCounter;//DS2423 Dual Counter
     if (sDallasFamily='20') {or (sDallasFamily='22')}
       then ProcessQuadADC;//DS2450 Quad ADC

     end;//preocess others
dec(cPlaceInMemo);
sRawData:=meRawReturns.lines[cPlaceInMemo];
until cPlaceInMemo<0;
end;//.."at least one.."
end;//TM128

end;//InterpretRecentLines

procedure TDD63f1.buWDSendBClick(Sender: TObject);
begin
eTextToSend.text:='B';
btnSendClick(toNull);
end;

procedure TDD63f1.buTM128RepeatedlyClick(Sender: TObject);
begin
if buTM128Repeatedly.caption<>'Read Repeatedly' then begin
   buTM128Repeatedly.caption:='Read Repeatedly';
   Timer1.enabled:=false;

   end//no ; here
  else begin
   buTM128Repeatedly.caption:='Stop Repeated Readings';
   Timer1.enabled:=true;
end;
end;

//Note to self... make basis of tut.. incl easy cretion of multiple rbs
procedure TDD63f1.rbTM128RClick(Sender: TObject);
     procedure GiveMsg;
     begin
       boTM128MsgGivenOnce:=true;
       showmessage('The TM128 takes about a second to return'+#13+
       'each sensor''s value, so if'+#13+
       'you have more than one sensor,'+#13+
       'you must not read the device too'+#13+
       'frequently. No harm will arise, but'+#13+
       'you will lose some data.');
     end;
begin
btnSendClick(toNull);
if sender=rbTM128R0 then begin
            if boTM128MsgGivenOnce then GiveMsg;
            timer1.interval:=800;
            laTM128HowOften.caption:='Every 0.8 second';
            end;
if sender=rbTM128R1 then begin
            if boTM128MsgGivenOnce then GiveMsg;
            timer1.interval:=2500;
            laTM128HowOften.caption:='Every 2.5 seconds';
            end;
if sender=rbTM128R2 then begin
            if boTM128MsgGivenOnce then GiveMsg;
            timer1.interval:=5000;
            laTM128HowOften.caption:='Every 5 seconds';
            end;
if sender=rbTM128R3 then  begin
            timer1.interval:=60000;
            laTM128HowOften.caption:='Every minute';
            end;
if sender=rbTM128R4 then begin
            timer1.interval:=60000*5;
            laTM128HowOften.caption:='Every 5 minutes';
            end;
if sender=rbTM128R5 then begin
            timer1.interval:=60000*30;
            laTM128HowOften.caption:='Every half hour';
            end;
// la..HowOften.caption setting could have been done with case..interval..of... 
end;

end.
